commit 2e17e920b0c22f432440ff83e53fd564a0473118
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Wed Dec 2 16:20:35 2020 +0000

    aarch64: Avoid false dependencies for SVE unary operations
    
    For calls like:
    
            z0 = svabs_s8_x (p0, z1)
    
    we previously generated:
    
            abs     z0.b, p0/m, z1.b
    
    However, this creates a false dependency on z0 (the merge input).
    This can lead to strange results in some cases, e.g. serialising
    the operation behind arbitrary earlier operations, or preventing
    two iterations of a loop from being executed in parallel.
    
    This patch therefore ties the input to the output, using a MOVPRFX
    if necessary and possible.  (The SVE2 unary long instructions do
    not support MOVPRFX.)
    
    When testing the patch, I hit a bug in the big-endian SVE move
    optimisation in aarch64_maybe_expand_sve_subreg_move.  I don't
    have an indepenedent testcase for it, so I didn't split it out
    into a separate patch.
    
    gcc/
            * config/aarch64/aarch64.c (aarch64_maybe_expand_sve_subreg_move):
            Do not optimize LRA subregs.
            * config/aarch64/aarch64-sve.md
            (@aarch64_pred_<SVE_INT_UNARY:optab><mode>): Tie the input to the
            output.
            (@aarch64_sve_revbhw_<SVE_ALL:mode><PRED_HSD:mode>): Likewise.
            (*<ANY_EXTEND:optab><SVE_PARTIAL_I:mode><SVE_HSDI:mode>2): Likewise.
            (@aarch64_pred_sxt<SVE_FULL_HSDI:mode><SVE_PARTIAL_I:mode>): Likewise.
            (*cnot<mode>): Likewise.
            (@aarch64_pred_<SVE_COND_FP_UNARY:optab><mode>): Likewise.
            (@aarch64_sve_<optab>_nontrunc<SVE_FULL_F:mode><SVE_FULL_HSDI:mode>):
            Likewise.
            (@aarch64_sve_<optab>_trunc<VNx2DF_ONLY:mode><VNx4SI_ONLY:mode>):
            Likewise.
            (@aarch64_sve_<optab>_nonextend<SVE_FULL_HSDI:mode><SVE_FULL_F:mode>):
            Likewise.
            (@aarch64_sve_<optab>_extend<VNx4SI_ONLY:mode><VNx2DF_ONLY:mode>):
            Likewise.
            (@aarch64_sve_<optab>_trunc<SVE_FULL_SDF:mode><SVE_FULL_HSF:mode>):
            Likewise.
            (@aarch64_sve_<optab>_trunc<VNx4SF_ONLY:mode><VNx8BF_ONLY:mode>):
            Likewise.
            (@aarch64_sve_<optab>_nontrunc<SVE_FULL_HSF:mode><SVE_FULL_SDF:mode>):
            Likewise.
            * config/aarch64/aarch64-sve2.md
            (@aarch64_pred_<SVE2_COND_FP_UNARY_LONG:sve_fp_op><mode>): Likewise.
            (@aarch64_pred_<SVE2_COND_FP_UNARY_NARROWB:sve_fp_op><mode>): Likewise.
            (@aarch64_pred_<SVE2_U32_UNARY:sve_int_op><mode>): Likewise.
            (@aarch64_pred_<SVE2_COND_INT_UNARY_FP:sve_fp_op><mode>): Likewise.
    
    gcc/testsuite/
            * gcc.target/aarch64/sve/cond_cnot_1.c: XFAIL movprfx test.
            * gcc.target/aarch64/sve/cond_unary_1.c: Likewise.
            * gcc.target/aarch64/sve/acle/asm/abs_f16.c (abs_f16_x_untied): Expect
            a MOVPRFX instruction.
            * gcc.target/aarch64/sve/acle/asm/abs_f32.c (abs_f32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/abs_f64.c (abs_f64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/abs_s16.c (abs_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/abs_s32.c (abs_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/abs_s64.c (abs_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/abs_s8.c (abs_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cls_s16.c (cls_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cls_s32.c (cls_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cls_s64.c (cls_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cls_s8.c (cls_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_s16.c (clz_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_s32.c (clz_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_s64.c (clz_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_s8.c (clz_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_u16.c (clz_u16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_u32.c (clz_u32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_u64.c (clz_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/clz_u8.c (clz_u8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_s16.c (cnot_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_s32.c (cnot_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_s64.c (cnot_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_s8.c (cnot_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_u16.c (cnot_u16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_u32.c (cnot_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_u64.c (cnot_u64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnot_u8.c (cnot_u8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_bf16.c (cnt_bf16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_f16.c (cnt_f16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_f32.c (cnt_f32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_f64.c (cnt_f64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_s16.c (cnt_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_s32.c (cnt_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_s64.c (cnt_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_s8.c (cnt_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_u16.c (cnt_u16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_u32.c (cnt_u32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_u64.c (cnt_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cnt_u8.c (cnt_u8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_bf16.c (cvt_bf16_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_f16.c (cvt_f16_f32_x_untied)
            (cvt_f16_f64_x_untied, cvt_f16_s16_x_untied, cvt_f16_s32_x_untied)
            (cvt_f16_s64_x_untied, cvt_f16_u16_x_untied, cvt_f16_u32_x_untied)
            (cvt_f16_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_f32.c (cvt_f32_f16_x_untied)
            (cvt_f32_f64_x_untied, cvt_f32_s16_x_untied, cvt_f32_s32_x_untied)
            (cvt_f32_s64_x_untied, cvt_f32_u16_x_untied, cvt_f32_u32_x_untied)
            (cvt_f32_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_f64.c (cvt_f64_f16_x_untied)
            (cvt_f64_f32_x_untied, cvt_f64_s16_x_untied, cvt_f64_s32_x_untied)
            (cvt_f64_s64_x_untied, cvt_f64_u16_x_untied, cvt_f64_u32_x_untied)
            (cvt_f64_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_s16.c (cvt_s16_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_s32.c (cvt_s32_f16_x_untied)
            (cvt_s32_f32_x_untied, cvt_s32_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_s64.c (cvt_s64_f16_x_untied)
            (cvt_s64_f32_x_untied, cvt_s64_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_u16.c (cvt_u16_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_u32.c (cvt_u32_f16_x_untied)
            (cvt_u32_f32_x_untied, cvt_u32_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/cvt_u64.c (cvt_u64_f16_x_untied)
            (cvt_u64_f32_x_untied, cvt_u64_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/extb_s16.c (extb_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/extb_s32.c (extb_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/extb_s64.c (extb_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/exth_s32.c (exth_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/exth_s64.c (exth_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/extw_s64.c (extw_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_f16.c (neg_f16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_f32.c (neg_f32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_f64.c (neg_f64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_s16.c (neg_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_s32.c (neg_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_s64.c (neg_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/neg_s8.c (neg_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_s16.c (not_s16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_s32.c (not_s32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_s64.c (not_s64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_s8.c (not_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_u16.c (not_u16_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_u32.c (not_u32_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_u64.c (not_u64_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/not_u8.c (not_u8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_s16.c (rbit_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_s32.c (rbit_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_s64.c (rbit_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_s8.c (rbit_s8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_u16.c (rbit_u16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_u32.c (rbit_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_u64.c (rbit_u64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rbit_u8.c (rbit_u8_x_untied): Ditto.
            * gcc.target/aarch64/sve/acle/asm/recpx_f16.c (recpx_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/recpx_f32.c (recpx_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/recpx_f64.c (recpx_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_s16.c (revb_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_s32.c (revb_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_s64.c (revb_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_u16.c (revb_u16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_u32.c (revb_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revb_u64.c (revb_u64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revh_s32.c (revh_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revh_s64.c (revh_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revh_u32.c (revh_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revh_u64.c (revh_u64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revw_s64.c (revw_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/revw_u64.c (revw_u64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinta_f16.c (rinta_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinta_f32.c (rinta_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinta_f64.c (rinta_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinti_f16.c (rinti_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinti_f32.c (rinti_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rinti_f64.c (rinti_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintm_f16.c (rintm_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintm_f32.c (rintm_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintm_f64.c (rintm_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintn_f16.c (rintn_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintn_f32.c (rintn_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintn_f64.c (rintn_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintp_f16.c (rintp_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintp_f32.c (rintp_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintp_f64.c (rintp_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintx_f16.c (rintx_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintx_f32.c (rintx_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintx_f64.c (rintx_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintz_f16.c (rintz_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintz_f32.c (rintz_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/rintz_f64.c (rintz_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/sqrt_f16.c (sqrt_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/sqrt_f32.c (sqrt_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve/acle/asm/sqrt_f64.c (sqrt_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/cvtx_f32.c (cvtx_f32_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/logb_f16.c (logb_f16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/logb_f32.c (logb_f32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/logb_f64.c (logb_f64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qabs_s16.c (qabs_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qabs_s32.c (qabs_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qabs_s64.c (qabs_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qabs_s8.c (qabs_s8_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qneg_s16.c (qneg_s16_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qneg_s32.c (qneg_s32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qneg_s64.c (qneg_s64_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/qneg_s8.c (qneg_s8_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/recpe_u32.c (recpe_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/rsqrte_u32.c (rsqrte_u32_x_untied):
            Ditto.
            * gcc.target/aarch64/sve2/acle/asm/cvtlt_f32.c
            (cvtlt_f32_f16_x_untied): Expect a MOV instruction.
            * gcc.target/aarch64/sve2/acle/asm/cvtlt_f64.c
            (cvtlt_f64_f32_x_untied): Likewise.
    
    (cherry picked from commit a4d9837ee4becaec43b77afa84ea2b91ee1b9e5c)

diff --git a/gcc/config/aarch64/aarch64.c b/gcc/config/aarch64/aarch64.c
index 7dde9867466..d54a5cf1265 100644
--- a/gcc/config/aarch64/aarch64.c
+++ b/gcc/config/aarch64/aarch64.c
@@ -5427,9 +5427,35 @@ bool
 aarch64_maybe_expand_sve_subreg_move (rtx dest, rtx src)
 {
   gcc_assert (BYTES_BIG_ENDIAN);
-  if (GET_CODE (dest) == SUBREG)
+
+  /* Do not try to optimize subregs that LRA has created for matched
+     reloads.  These subregs only exist as a temporary measure to make
+     the RTL well-formed, but they are exempt from the usual
+     TARGET_CAN_CHANGE_MODE_CLASS rules.
+
+     For example, if we have:
+
+       (set (reg:VNx8HI R1) (foo:VNx8HI (reg:VNx4SI R2)))
+
+     and the constraints require R1 and R2 to be in the same register,
+     LRA may need to create RTL such as:
+
+       (set (subreg:VNx4SI (reg:VNx8HI TMP) 0) (reg:VNx4SI R2))
+       (set (reg:VNx8HI TMP) (foo:VNx8HI (subreg:VNx4SI (reg:VNx8HI TMP) 0)))
+       (set (reg:VNx8HI R1) (reg:VNx8HI TMP))
+
+     which forces both the input and output of the original instruction
+     to use the same hard register.  But for this to work, the normal
+     rules have to be suppressed on the subreg input, otherwise LRA
+     would need to reload that input too, meaning that the process
+     would never terminate.  To compensate for this, the normal rules
+     are also suppressed for the subreg output of the first move.
+     Ignoring the special case and handling the first move normally
+     would therefore generate wrong code: we would reverse the elements
+     for the first subreg but not reverse them back for the second subreg.  */
+  if (SUBREG_P (dest) && !LRA_SUBREG_P (dest))
     dest = SUBREG_REG (dest);
-  if (GET_CODE (src) == SUBREG)
+  if (SUBREG_P (src) && !LRA_SUBREG_P (src))
     src = SUBREG_REG (src);
 
   /* The optimization handles two single SVE REGs with different element
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f16.c
index 2aa8736e645..09605324cd2 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f16.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_f16_x_tied1, svfloat16_t,
 
 /*
 ** abs_f16_x_untied:
+**	movprfx	z0, z1
 **	fabs	z0\.h, p0/m, z1\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f32.c
index 30286afc7b7..797a4187af9 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f32.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_f32_x_tied1, svfloat32_t,
 
 /*
 ** abs_f32_x_untied:
+**	movprfx	z0, z1
 **	fabs	z0\.s, p0/m, z1\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f64.c
index 28ef9fbba23..4290ac390d1 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_f64.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_f64_x_tied1, svfloat64_t,
 
 /*
 ** abs_f64_x_untied:
+**	movprfx	z0, z1
 **	fabs	z0\.d, p0/m, z1\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s16.c
index 3b16a9c4f03..fcd5c3413bf 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s16.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_s16_x_tied1, svint16_t,
 
 /*
 ** abs_s16_x_untied:
+**	movprfx	z0, z1
 **	abs	z0\.h, p0/m, z1\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s32.c
index 14bcbd50c46..58d183ed940 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s32.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_s32_x_tied1, svint32_t,
 
 /*
 ** abs_s32_x_untied:
+**	movprfx	z0, z1
 **	abs	z0\.s, p0/m, z1\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s64.c
index c7b60ff4843..2842048d4eb 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s64.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_s64_x_tied1, svint64_t,
 
 /*
 ** abs_s64_x_untied:
+**	movprfx	z0, z1
 **	abs	z0\.d, p0/m, z1\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s8.c
index 0bc64c078a2..ec0d89d8ba9 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/abs_s8.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (abs_s8_x_tied1, svint8_t,
 
 /*
 ** abs_s8_x_untied:
+**	movprfx	z0, z1
 **	abs	z0\.b, p0/m, z1\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s16.c
index 7af312397b9..5f82612c97a 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s16.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cls_s16_z, svuint16_t, svint16_t,
 
 /*
 ** cls_s16_x:
+**	movprfx	z0, z4
 **	cls	z0\.h, p0/m, z4\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s32.c
index 813876f6877..0db651f2e29 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s32.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cls_s32_z, svuint32_t, svint32_t,
 
 /*
 ** cls_s32_x:
+**	movprfx	z0, z4
 **	cls	z0\.s, p0/m, z4\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s64.c
index 660a20556c8..e809e2fb2ab 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s64.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cls_s64_z, svuint64_t, svint64_t,
 
 /*
 ** cls_s64_x:
+**	movprfx	z0, z4
 **	cls	z0\.d, p0/m, z4\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s8.c
index 56f5c26086f..f296c9f932f 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cls_s8.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cls_s8_z, svuint8_t, svint8_t,
 
 /*
 ** cls_s8_x:
+**	movprfx	z0, z4
 **	cls	z0\.b, p0/m, z4\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s16.c
index 58f89005cd5..dc2c4e952f7 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s16.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (clz_s16_z, svuint16_t, svint16_t,
 
 /*
 ** clz_s16_x:
+**	movprfx	z0, z4
 **	clz	z0\.h, p0/m, z4\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s32.c
index a9198070b58..17f54bcd056 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s32.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (clz_s32_z, svuint32_t, svint32_t,
 
 /*
 ** clz_s32_x:
+**	movprfx	z0, z4
 **	clz	z0\.s, p0/m, z4\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s64.c
index 02c0c993e0b..a42b730c564 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s64.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (clz_s64_z, svuint64_t, svint64_t,
 
 /*
 ** clz_s64_x:
+**	movprfx	z0, z4
 **	clz	z0\.d, p0/m, z4\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s8.c
index 642d298c8ef..66c23594f05 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_s8.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (clz_s8_z, svuint8_t, svint8_t,
 
 /*
 ** clz_s8_x:
+**	movprfx	z0, z4
 **	clz	z0\.b, p0/m, z4\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u16.c
index f0872301759..ab31f567aee 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u16.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (clz_u16_x_tied1, svuint16_t,
 
 /*
 ** clz_u16_x_untied:
+**	movprfx	z0, z1
 **	clz	z0\.h, p0/m, z1\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u32.c
index e0042413162..2a7440455a8 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u32.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (clz_u32_x_tied1, svuint32_t,
 
 /*
 ** clz_u32_x_untied:
+**	movprfx	z0, z1
 **	clz	z0\.s, p0/m, z1\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u64.c
index e879e1b9a6e..8ff73c42409 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u64.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (clz_u64_x_tied1, svuint64_t,
 
 /*
 ** clz_u64_x_untied:
+**	movprfx	z0, z1
 **	clz	z0\.d, p0/m, z1\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u8.c
index ce6cb8f4517..89d8c54079c 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/clz_u8.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (clz_u8_x_tied1, svuint8_t,
 
 /*
 ** clz_u8_x_untied:
+**	movprfx	z0, z1
 **	clz	z0\.b, p0/m, z1\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s16.c
index 19d46be68b5..8f047fbbc0a 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s16.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_s16_x_tied1, svint16_t,
 
 /*
 ** cnot_s16_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.h, p0/m, z1\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s32.c
index 041b59a046c..f5b33959da2 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s32.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_s32_x_tied1, svint32_t,
 
 /*
 ** cnot_s32_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.s, p0/m, z1\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s64.c
index c7135cb9568..64121e3f0e1 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s64.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_s64_x_tied1, svint64_t,
 
 /*
 ** cnot_s64_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.d, p0/m, z1\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s8.c
index 0560f97516b..e5dab42ad5e 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_s8.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_s8_x_tied1, svint8_t,
 
 /*
 ** cnot_s8_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.b, p0/m, z1\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u16.c
index 7ea9ff71ded..74c72c9ee0f 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u16.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_u16_x_tied1, svuint16_t,
 
 /*
 ** cnot_u16_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.h, p0/m, z1\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u32.c
index 972c7751eb6..b0f7531ee08 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u32.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_u32_x_tied1, svuint32_t,
 
 /*
 ** cnot_u32_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.s, p0/m, z1\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u64.c
index f25e001c569..9aa698dfbbf 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u64.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_u64_x_tied1, svuint64_t,
 
 /*
 ** cnot_u64_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.d, p0/m, z1\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u8.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u8.c
index e135a72956a..67c46a2dd81 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u8.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnot_u8.c
@@ -73,6 +73,7 @@ TEST_UNIFORM_Z (cnot_u8_x_tied1, svuint8_t,
 
 /*
 ** cnot_u8_x_untied:
+**	movprfx	z0, z1
 **	cnot	z0\.b, p0/m, z1\.b
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_bf16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_bf16.c
index d92fbc1572d..bebf3612834 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_bf16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_bf16.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cnt_bf16_z, svuint16_t, svbfloat16_t,
 
 /*
 ** cnt_bf16_x:
+**	movprfx	z0, z4
 **	cnt	z0\.h, p0/m, z4\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f16.c
index b8061bb80dd..20c95d62121 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f16.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cnt_f16_z, svuint16_t, svfloat16_t,
 
 /*
 ** cnt_f16_x:
+**	movprfx	z0, z4
 **	cnt	z0\.h, p0/m, z4\.h
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f32.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f32.c
index b9292c97709..8afeb49da4f 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f32.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f32.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cnt_f32_z, svuint32_t, svfloat32_t,
 
 /*
 ** cnt_f32_x:
+**	movprfx	z0, z4
 **	cnt	z0\.s, p0/m, z4\.s
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f64.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f64.c
index 4976ee467a2..b7683a97f68 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f64.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_f64.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cnt_f64_z, svuint64_t, svfloat64_t,
 
 /*
 ** cnt_f64_x:
+**	movprfx	z0, z4
 **	cnt	z0\.d, p0/m, z4\.d
 **	ret
 */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_s16.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_s16.c
index a8ff8f3d2cf..824c42ad549 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_s16.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/asm/cnt_s16.c
@@ -33,6 +33,7 @@ TEST_DUAL_Z (cnt_s16_z, svuint16_t, svint16_t,
 
 /*
 ** cnt_s16_x:
+**	movprfx	z0, z4
 **	cnt	z0\.h, p0/m, z4\.h
 **	ret
 */
